include("DateExpFunction.js");

var com_SelectedDate = null;
var com_frmCalendarBody = null;
var com_SundayColor = '#FF0000';
var com_SaturdayColor = '#00FFFF';
var com_WorkdayColor = '#FFFFFF';
var com_ShadowColor = '#000000';
var com_TodayColor = '#FF8000';
var com_SelectedDateColor = '#FF00FF';
var com_CallBack = null;

function com_StartSelect(v) {
	if (v == null || typeof(v) == 'undefined')
		com_SelectedDate = new Date();
	else
		com_SelectedDate = v;
	
	com_frmHeader.addSubview(com_GetWeekTitles());
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoPrevMonth() {
	com_SelectedDate = com_SelectedDate.DateAdd('m', -1);
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoToday() {
	com_SelectedDate = new Date();
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoNextMonth() {
	com_SelectedDate = com_SelectedDate.DateAdd('m', 1);
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_DrawCalendar(year, month) {
	if (com_frmCalendarBody != null)
		com_frmCalendarBody.removeFromSuperview();
	com_txtMonth.data = year + '/' + month;
	com_frmCalendarBody = com_GetCalendar(year, month);
	com_CalendarBody.addSubview(com_frmCalendarBody);
}

function com_CellDblClick(idx) {
	com_SelectedDate.setDate(idx + 1);
}

function com_GetWeekTitles() {
	var frame = new Frame();
	frame.hOffset = 10;
	frame.vOffset = 35;
	frame.width = com_frmHeader.width;
	frame.height = 50;
	var width = Math.floor((frame.width - 20) / 7);
	var s = GetShadow();
	for (var i = 0; i < 7; i++) {
		var t = new Text();
		t.data = c_WeekDay[i];
		t.vOffset = 15;
		t.hOffset = width * (i + 1) - 2;
		t.width = width;
		t.height = 14;
		t.font = 'Arial';
		t.size = 14;
		t.truncation = 'none';
		t.hAlign = 'right';
		t.shadow = s;
		switch (i) {
			case 0:
				t.color = com_SundayColor;
				break;
			case 6:
				t.color = com_SaturdayColor;
				break;
			default:
				t.color = com_WorkdayColor;
				break;
		}
		frame.addSubview(t);
	}
	return frame;
}

function com_GetCalendar(year, month) {
	var firstDate = new Date(year, month - 1, 1);
	var lastDate = new Date(year, month, 1);
	var monthDays = firstDate.DateDiff('d', lastDate);
	var totalDays = monthDays + firstDate.getDay() + (7 - lastDate.getDay());
	var weeks = totalDays / 7;
	var s = com_GetShadow();
	var frame = new Frame();
	frame.hOffset = 0;
	frame.vOffset = 10;
	frame.width = com_CalendarBody.width;
	frame.height = com_CalendarBody.height;
	var width = Math.floor((frame.width - 20) / 7);
	for (var i = 0; i < weeks; i++) {
		for (var j = 0; j < 7; j++) {
			var idx = i * 7 + j - firstDate.getDay();
			if (idx < 0 || idx >= monthDays)
				continue;

			var cell = new Text();
			cell.data = idx + 1;
			if (cell.data.length == 1)
				cell.data = ' ' + cell.data;
			cell.width = width - 15;
			cell.height = 16;
			cell.hOffset = (j + 1) * width + 8;
			cell.vOffset = i * (cell.height + 7) + 10;
			cell.font = 'Arial';
			cell.size = 14;
			cell.shadow = s;
			cell.hAlign = 'right';
			var cellDate = new Date(year, month - 1, idx + 1);
			switch (j) {
				case 0:
					cell.color = com_SundayColor;
					break;
				case 6:
					cell.color = com_SaturdayColor;
					break;
				default:
					cell.color = com_WorkdayColor;
					break;
			}
			if (cellDate.DateDiff('d', new Date()) == 0) {
				com_imgToday.hOffset = cell.hOffset - cell.width - 1;
				com_imgToday.vOffset = cell.vOffset - 4;
			} else {
			}
			cell.onMouseEnter = 'com_CellMouseEnter(' + idx + ');';
			cell.onMultiClick = 'com_CellMultiClick(' + idx + ');';
			if (cellDate.DateDiff('d', com_SelectedDate) == 0) {
				com_imgSelected.hOffset = cell.hOffset - cell.width - 1;
				com_imgSelected.vOffset = cell.vOffset - 4;
			}
			frame.addSubview(cell);
		}
	}
	if (cellDate.DateDiff('m', new Date()) == 0)
		com_imgToday.visible = true;
	else
		com_imgToday.visible = false;
	if (cellDate.DateDiff('m', com_SelectedDate) == 0)
		com_imgSelected.visible = true;
	else
		com_imgSelected.visible = false;
	com_imgFocus.visible = false;
	return frame;
}

function com_GetShadow() {
	var s = new Shadow();
	s.vOffset = 1;
	s.hOffset = 1;
	s.color = com_ShadowColor;
	return s;
}

function com_CellMouseEnter(idx) {
	var cell = com_frmCalendarBody.subviews[idx];
	com_imgFocus.hOffset = cell.hOffset - cell.width - 1;
	com_imgFocus.vOffset = cell.vOffset - 4;
	com_imgFocus.visible = true;
}

function com_CellMultiClick(idx) {
	if (system.event.clickCount < 2)
		return;
	com_SelectedDate = new Date(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth(), idx + 1);
	var cell = com_frmCalendarBody.subviews[idx];
	com_imgSelected.hOffset = cell.hOffset - cell.width - 1;
	com_imgSelected.vOffset = cell.vOffset - 4;
	com_imgSelected.visible = true;
	eval(com_CallBack());
}