var langFile = 'Resources\\Languages\\' + widget.locale + '.js';
if (filesystem.itemExists(langFile))
	include(langFile);
else
	include('Resources\\Languages\\en.js');
include('CommonCalendar.js');
include('Utils.js');
include('SettingForm.js');

var panHeader = null;
var panCalendar = null;
var var_MCCycle = 28;
var var_MCDate = null;
var my_Today = new Date();
var my_SelectedMonth = null;
var my_CellWidth = Math.floor((frmCalendar.width - 10) / 7);
var my_WindowIsExpand = false;

SetLenguage();
initWidget();
preferences.preMCDate.value = null;
preferences.preMCCycle.value = null;

function initWidget() {
	if (preferences.preMCDate.value == 'null') {
		var_MCDate = my_Today.toFormatString('ed', true);
		var_MCCycle = 28;
		txtMCDate.data = var_MCDate;
		txtMCCycle.data = var_MCCycle;
		sbMCCycle.value = var_MCCycle - 23;
		winSetting.visible = true;
	} else {
		StartUp();
	}
}

function StartUp() {
	frmHeader.addSubview(GetHeader());
	my_SelectedMonth = new Date(var_MCDate.getFullYear(), var_MCDate.getMonth(), 1);
	DrawCalendar(my_SelectedMonth.getFullYear(), my_SelectedMonth.getMonth() + 1);
	winMain.visible = true;
}
function DrawCalendar(year, month) {
	if (panHeader != null)
		panHeader.removeFromSuperview();
	if (panCalendar != null)
		panCalendar.removeFromSuperview();
	panHeader = GetDisplayMonth(year, month);
	frmDisplay.addSubview(panHeader);

	panCalendar = GetCalendar(year, month)
	frmCalendar.addSubview(panCalendar);
	updateNow();
}

function GetCalendar(year, month) {
	var firstDate = new Date(year, month - 1, 1);
	var lastDate = new Date(year, month, 1);
	var monthDays = firstDate.DateDiff('d', lastDate);
	var totalDays = monthDays + firstDate.getDay() + (7 - lastDate.getDay());
	var weeks = totalDays / 7;
	var monthMCs = GetMonthMCDate(var_MCDate, var_MCCycle, year, month);
	if (monthMCs.length == 0)
		var ovulDate = null;
	else
		var ovulDate = GetOvulateDate(monthMCs[0], var_MCCycle);
	var frame = new Frame();
	frame.hOffset = 0;
	frame.vOffset = 3;
	frame.width = frmCalendar.width;
	frame.height = frmCalendar.height;
	for (var i = 0; i < weeks; i++) {
		for (var j = 0; j < 7; j++) {
			var idx = i * 7 + j - firstDate.getDay();
			if (idx < 0 || idx >= monthDays)
				continue;
			var cellDate = new Date(year, month - 1, idx + 1);
			var cell = GetCell(idx, i, j)
			var chkNext = true;
			for (var z = 0; z < monthMCs.length; z++) {
				if (monthMCs[z].DateDiff('d', cellDate) == 0) {
					var img = new Image();
					img.src = 'Resources/Images/Rose.png';
					img.hOffset = cell.hOffset + 10;
					img.vOffset = cell.vOffset - 2;
					img.width = c_ImageWidth;
					img.height = c_ImageHeight;
					frame.addSubview(img);
					frame.addSubview(GetMCText(i, j));
					cell.tooltip = cd_MCDate;
					chkNext = false;
				}
			}
			if (ovulDate != null) {
				if (chkNext && 
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == 0) || (ovulDate.NextOvul.DateDiff('d', cellDate) == 0)) ||
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == 1) || (ovulDate.NextOvul.DateDiff('d', cellDate) == 1)) ||
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == 2) || (ovulDate.NextOvul.DateDiff('d', cellDate) == 2)) ) {
					var img = new Image();
					img.src = 'Resources/Images/Pacifier-B.png';
					img.hOffset = cell.hOffset + 10;
					img.vOffset = cell.vOffset - 2;
					img.width = c_ImageWidth;
					img.height = c_ImageHeight;
					frame.addSubview(img);
					if ((ovulDate.PrevOvul.DateDiff('d', cellDate) == 0) || (ovulDate.NextOvul.DateDiff('d', cellDate) == 0)) {
						frame.addSubview(GetOvulateText(i, j));
						cell.tooltip = cd_OvulateDate;
					} else {
						cell.tooltip = cd_OvulBoy;
					}
					chkNext = false;
				}
				if (chkNext && 
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == -1) || (ovulDate.NextOvul.DateDiff('d', cellDate) == -1)) ||
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == -2) || (ovulDate.NextOvul.DateDiff('d', cellDate) == -2)) ||
					((ovulDate.PrevOvul.DateDiff('d', cellDate) == -3) || (ovulDate.NextOvul.DateDiff('d', cellDate) == -3)) ) {
					var img = new Image();
					img.src = 'Resources/Images/Pacifier-R.png';
					img.hOffset = cell.hOffset + 10;
					img.vOffset = cell.vOffset - 2;
					img.width = c_ImageWidth;
					img.height = c_ImageHeight;
					frame.addSubview(img);
					cell.tooltip = cd_OvulGirl;
					chkNext = false;
				}
			}
			if (chkNext) {
				var img = new Image();
				img.src = 'Resources/Images/Rose.png';
				img.hOffset = cell.hOffset + 10;
				img.vOffset = cell.vOffset - 2;
				img.width = c_ImageWidth;
				img.height = c_ImageHeight;
				cell.tooltip = cd_SexDate;
				frame.addSubview(img);
			}
			frame.addSubview(cell);
		}
	}
	return frame;
}

function GetCell(idx, i, j) {
	var cell = new Text();
	cell.data = idx + 1;
	cell.hOffset = j * my_CellWidth + c_CellSpacing + 2;
	cell.vOffset = i * c_CellHeight + c_CellSpacing + 10;
	cell.width = my_CellWidth - (c_CellSpacing + 2);
	cell.height = c_CellHeight - c_CellSpacing;
	cell.font = 'Arial';
	cell.size = 12;
	cell.shadow = GetShadow();
	switch (j) {
		case 0:
			cell.color = my_SubdayColor;
			break;
		case 6:
			cell.color = my_SaturdayColor;
			break;
		default:
			cell.color = my_WorkDayColor;
			break;
	}
	return cell;
}

function GetOvulateText(i, j) {
	var cell = new Text();
	cell.data = cl_Ovulate;
	cell.hOffset = j * my_CellWidth + c_CellSpacing + 2;
	cell.vOffset = i * c_CellHeight + c_CellSpacing + 27;
	cell.font = 'Arial';
	cell.size = 12;
	cell.shadow = GetShadow();
	cell.color = '#FF0000';
	return cell;
}

function GetMCText(i, j) {
	var cell = new Text();
	cell.data = cl_MC;
	cell.hOffset = j * my_CellWidth + c_CellSpacing + 2;
	cell.vOffset = i * c_CellHeight + c_CellSpacing + 27;
	cell.font = 'Arial';
	cell.size = 12;
	cell.shadow = GetShadow();
	cell.color = '#FF0000';
	return cell;
}

function GetDisplayMonth(year, month) {
	var frame = new Frame();
	var theMonth = new Text();
	theMonth.data = year + '/' + month;
	theMonth.vOffset = 20;
	theMonth.hOffset = 300;
	theMonth.width = 80;
	theMonth.height = 24;
	theMonth.font = 'Arial';
	theMonth.size = 18;
	theMonth.truncation = 'none';
	theMonth.alignment = 'right';
	theMonth.color = my_MonthColor;
	theMonth.shadow = GetShadow();
	frame.addSubview(theMonth);
	return frame;
}

function GetHeader() {
	var frame = new Frame();
	frame.hOffset = 0;
	frame.vOffset = 0;
	frame.width = frmCalendar.width;
	frame.height = 20;
	var width = my_CellWidth;
	var s = GetShadow();
	for (var i = 0; i < 7; i++) {
		var t = new Text();
		t.data = c_WeekDay[i];
		t.vOffset = 16;
		t.hOffset = width * i + 25 + ((i == 0) ? 0 : c_CellSpacing);
		t.width = width;
		t.height = 14;
		t.font = 'Arial';
		t.size = 14;
		t.truncation = 'none';
		t.hAlign = 'center';
		t.shadow = s;
		switch (i) {
			case 0:
				t.color = my_SubdayColor;
				break;
			case 6:
				t.color = my_SaturdayColor;
				break;
			default:
				t.color = my_WorkDayColor;
				break;
		}
		frame.addSubview(t);
	}
	return frame;
}

function GetShadow() {
	var s = new Shadow();
	s.vOffset = 1;
	s.hOffset = 1;
	s.color = my_ShadowColor;
	return s;
}

function GoPrevMonth() {
	my_SelectedMonth = my_SelectedMonth.DateAdd('m', -1);
	DrawCalendar(my_SelectedMonth.getFullYear(), my_SelectedMonth.getMonth() + 1);
}

function GoToday() {
	my_SelectedMonth = new Date(my_Today.getFullYear(), my_Today.getMonth(), 1);
	DrawCalendar(my_SelectedMonth.getFullYear(), my_SelectedMonth.getMonth() + 1);
}

function GoNextMonth() {
	my_SelectedMonth = my_SelectedMonth.DateAdd('m', 1);
	DrawCalendar(my_SelectedMonth.getFullYear(), my_SelectedMonth.getMonth() + 1);
}

function btnReset_onMouseUp() {
	btnReset.src = 'Resources/Images/Buttons/Normal.png';
	winMain.visible = false;
	winSetting.visible = true;
}

